/*
This file is part of mfaktc.
Copyright (C) 2012  George Woltman (woltman@alum.mit.edu)

mfaktc is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

mfaktc is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with mfaktc.  If not, see <http://www.gnu.org/licenses/>.
*/


__device__ static void mulsub_160_M89_initial_special(int160 *res, int160 a, int160 negb)
/* res = 0 - a * b (only lower 160 bits of the result), a.d4 is zero. */
{
  asm("{\n\t"
      "mul.lo.u32      %0, %5, %10;\n\t"      /* 0 += (a.d0 * negb.d0).lo */
      "mul.lo.u32      %1, %5, %11;\n\t"      /* 0 += (a.d0 * negb.d1).lo */
      "mul.lo.u32      %2, %5, %12;\n\t"      /* 0 += (a.d0 * negb.d2).lo */
      "mul.lo.u32      %3, %5, %13;\n\t"      /* 0 += (a.d0 * negb.d3).lo */
      "mul.lo.u32      %4, %5, %14;\n\t"      /* 0 += (a.d0 * negb.d4).lo */

      "mad.hi.cc.u32   %1, %5, %10, %1;\n\t"  /* 0 += (a.d0 * negb.d0).hi */
      "madc.hi.cc.u32  %2, %5, %11, %2;\n\t"  /* 0 += (a.d0 * negb.d1).hi */
      "madc.hi.cc.u32  %3, %5, %12, %3;\n\t"  /* 0 += (a.d0 * negb.d2).hi */
      "madc.hi.u32     %4, %5, %13, %4;\n\t"  /* 0 += (a.d0 * negb.d3).hi */

      "mad.lo.cc.u32   %1, %6, %10, %1;\n\t"  /* 0 += (a.d1 * negb.d0).lo */
      "madc.lo.cc.u32  %2, %6, %11, %2;\n\t"  /* 0 += (a.d1 * negb.d1).lo */
      "madc.lo.cc.u32  %3, %6, %12, %3;\n\t"  /* 0 += (a.d1 * negb.d2).lo */
      "madc.lo.u32     %4, %6, %13, %4;\n\t"  /* 0 += (a.d1 * negb.d3).lo */

      "mad.hi.cc.u32   %2, %6, %10, %2;\n\t"  /* 0 += (a.d1 * negb.d0).hi */
      "madc.hi.cc.u32  %3, %6, %11, %3;\n\t"  /* 0 += (a.d1 * negb.d1).hi */
      "madc.hi.u32     %4, %6, %12, %4;\n\t"  /* 0 += (a.d1 * negb.d2).hi */

      "mad.lo.cc.u32   %2, %7, %10, %2;\n\t"  /* 0 += (a.d2 * negb.d0).lo */
      "madc.lo.cc.u32  %3, %7, %11, %3;\n\t"  /* 0 += (a.d2 * negb.d1).lo */
      "madc.lo.u32     %4, %7, %12, %4;\n\t"  /* 0 += (a.d2 * negb.d2).lo */

      "mad.hi.cc.u32   %3, %7, %10, %3;\n\t"  /* 0 += (a.d2 * negb.d0).hi */
      "madc.hi.u32     %4, %7, %11, %4;\n\t"  /* 0 += (a.d2 * negb.d1).hi */

      "mad.lo.cc.u32   %3, %8, %10, %3;\n\t"  /* 0 += (a.d3 * negb.d0).lo */
      "madc.lo.u32     %4, %8, %11, %4;\n\t"  /* 0 += (a.d3 * negb.d1).lo */

      "mad.hi.u32      %4, %8, %10, %4;\n\t"  /* 0 += (a.d3 * negb.d0).hi */
      "}"
      : "=r" (res->d0), "=r" (res->d1), "=r" (res->d2), "=r" (res->d3), "=r" (res->d4)
      : "r" (a.d0), "r" (a.d1), "r" (a.d2), "r" (a.d3), "r" (a.d4),
        "r" (negb.d0), "r" (negb.d1), "r" (negb.d2), "r" (negb.d3), "r" (negb.d4));
}


__device__ static void mulsub_192_160_M89_initial_special16(int192 *res, int192 a, int160 negb)
/* res = 0 - a * b (only lower 192 bits of the result), a.d4, a.d5 are zero, negb.d5 is 0xFFFFFFFF */
{
  asm("{\n\t"
      "mul.lo.u32      %0, %6, %12;\n\t"       /* 0 += (a.d0 * negb.d0).lo */
      "mul.lo.u32      %1, %6, %13;\n\t"       /* 0 += (a.d0 * negb.d1).lo */
      "mul.lo.u32      %2, %6, %14;\n\t"       /* 0 += (a.d0 * negb.d2).lo */
      "mul.lo.u32      %3, %6, %15;\n\t"       /* 0 += (a.d0 * negb.d3).lo */
      "mul.lo.u32      %4, %6, %16;\n\t"       /* 0 += (a.d0 * negb.d4).lo */

      "mad.hi.cc.u32   %1, %6, %12, %1;\n\t"   /* 0 += (a.d0 * negb.d0).hi */
      "madc.hi.cc.u32  %2, %6, %13, %2;\n\t"   /* 0 += (a.d0 * negb.d1).hi */
      "madc.hi.cc.u32  %3, %6, %14, %3;\n\t"   /* 0 += (a.d0 * negb.d2).hi */
      "madc.hi.cc.u32  %4, %6, %15, %4;\n\t"   /* 0 += (a.d0 * negb.d3).hi */
      "madc.hi.u32     %5, %6, %16, 0;\n\t"    /* 0 += (a.d0 * negb.d4).hi */

      "mad.lo.cc.u32   %1, %7, %12, %1;\n\t"   /* 0 += (a.d1 * negb.d0).lo */
      "madc.lo.cc.u32  %2, %7, %13, %2;\n\t"   /* 0 += (a.d1 * negb.d1).lo */
      "madc.lo.cc.u32  %3, %7, %14, %3;\n\t"   /* 0 += (a.d1 * negb.d2).lo */
      "madc.lo.cc.u32  %4, %7, %15, %4;\n\t"   /* 0 += (a.d1 * negb.d3).lo */
      "madc.lo.u32     %5, %7, %16, %5;\n\t"   /* 0 += (a.d1 * negb.d4).lo */

      "mad.hi.cc.u32   %2, %7, %12, %2;\n\t"   /* 0 += (a.d1 * negb.d0).hi */
      "madc.hi.cc.u32  %3, %7, %13, %3;\n\t"   /* 0 += (a.d1 * negb.d1).hi */
      "madc.hi.cc.u32  %4, %7, %14, %4;\n\t"   /* 0 += (a.d1 * negb.d2).hi */
      "madc.hi.u32     %5, %7, %15, %5;\n\t"   /* 0 += (a.d1 * negb.d3).hi */

      "mad.lo.cc.u32   %2, %8, %12, %2;\n\t"   /* 0 += (a.d2 * negb.d0).lo */
      "madc.lo.cc.u32  %3, %8, %13, %3;\n\t"   /* 0 += (a.d2 * negb.d1).lo */
      "madc.lo.cc.u32  %4, %8, %14, %4;\n\t"   /* 0 += (a.d2 * negb.d2).lo */
      "madc.lo.u32     %5, %8, %15, %5;\n\t"   /* 0 += (a.d2 * negb.d3).lo */

      "mad.hi.cc.u32   %3, %8, %12, %3;\n\t"   /* 0 += (a.d2 * negb.d0).hi */
      "madc.hi.cc.u32  %4, %8, %13, %4;\n\t"   /* 0 += (a.d2 * negb.d1).hi */
      "madc.hi.u32     %5, %8, %14, %5;\n\t"   /* 0 += (a.d2 * negb.d2).hi */

      "mad.lo.cc.u32   %3, %9, %12, %3;\n\t"   /* 0 += (a.d3 * negb.d0).lo */
      "madc.lo.cc.u32  %4, %9, %13, %4;\n\t"   /* 0 += (a.d3 * negb.d1).lo */
      "madc.lo.u32     %5, %9, %14, %5;\n\t"   /* 0 += (a.d3 * negb.d2).lo */

      "mad.hi.cc.u32   %4, %9, %12, %4;\n\t"   /* 0 += (a.d3 * negb.d0).hi */
      "madc.hi.u32     %5, %9, %13, %5;\n\t"   /* 0 += (a.d3 * negb.d1).hi */

      "sub.u32         %5, %5, %6;\n\t"        /* 0 += (a.d0 * negb.d5).lo */
      "}"
      : "=r" (res->d0), "=r" (res->d1), "=r" (res->d2), "=r" (res->d3), "=r" (res->d4), "=r" (res->d5)
      : "r" (a.d0), "r" (a.d1), "r" (a.d2), "r" (a.d3), "r" (a.d4), "r" (a.d5),
        "r" (negb.d0), "r" (negb.d1), "r" (negb.d2), "r" (negb.d3), "r" (negb.d4));
}


//
// Kernel to factor MM89, works on f between 113 and 128 bits inclusive (k = 2^23 to k = 2^38)
//

__global__ void
__launch_bounds__(THREADS_PER_BLOCK, KERNEL_MAX_BLOCKS) mfaktc_barrett128_M89gs(int96 k_base, unsigned int *bit_array, unsigned int bits_to_process, unsigned int *RES)
{
  int i, words_per_thread, sieve_word, k_bit_base, total_bit_count;
  int128 f, finalrem;
  __shared__ volatile unsigned short bitcount[256];	// Each thread of our block puts bit-counts here
  extern __shared__ unsigned short smem[];		// Write bits to test here.  Launching program must estimate
							// how much shared memory to allocate based on number of primes sieved.

  // Get pointer to section of the bit_array this thread is processing.

  words_per_thread = bits_to_process / 8192;
  bit_array += blockIdx.x * bits_to_process / 32 + threadIdx.x * words_per_thread;

// Count number of bits set in this thread's word(s) from the bit_array

  bitcount[threadIdx.x] = 0;
  for (i = 0; i < words_per_thread; i++)
    bitcount[threadIdx.x] += ___popcnt(bit_array[i]);

// Create total count of bits set in block up to and including this threads popcnt.
// Kudos to Rocke Verser for the population counting code.
// CAUTION:  Following requires 256 threads per block

  // First five tallies remain within one warp.  Should be in lock-step.
  if (threadIdx.x & 1)        // If we are running on any thread 0bxxxxxxx1, tally neighbor's count.
    bitcount[threadIdx.x] += bitcount[threadIdx.x - 1];

  if (threadIdx.x & 2)        // If we are running on any thread 0bxxxxxx1x, tally neighbor's count.
    bitcount[threadIdx.x] += bitcount[(threadIdx.x - 2) | 1];

  if (threadIdx.x & 4)        // If we are running on any thread 0bxxxxx1xx, tally neighbor's count.
    bitcount[threadIdx.x] += bitcount[(threadIdx.x - 4) | 3];

  if (threadIdx.x & 8)        // If we are running on any thread 0bxxxx1xxx, tally neighbor's count.
    bitcount[threadIdx.x] += bitcount[(threadIdx.x - 8) | 7];

  if (threadIdx.x & 16)       // If we are running on any thread 0bxxx1xxxx, tally neighbor's count.
    bitcount[threadIdx.x] += bitcount[(threadIdx.x - 16) | 15];

  // Further tallies are across warps.  Must synchronize
  __syncthreads();
  if (threadIdx.x  & 32)      // If we are running on any thread 0bxx1xxxxx, tally neighbor's count.
    bitcount[threadIdx.x] += bitcount[(threadIdx.x - 32) | 31];

  __syncthreads();
  if (threadIdx.x & 64)       // If we are running on any thread 0bx1xxxxxx, tally neighbor's count.
    bitcount[threadIdx.x] += bitcount[(threadIdx.x - 64) | 63];

  __syncthreads();
  if (threadIdx.x & 128)       // If we are running on any thread 0b1xxxxxxx, tally neighbor's count.
    bitcount[threadIdx.x] += bitcount[127];

  // At this point, bitcount[...] contains the total number of bits for the indexed
  // thread plus all lower-numbered threads.  I.e., bitcount[255] is the total count.

  __syncthreads();
  total_bit_count = bitcount[255];

//POSSIBLE OPTIMIZATION - bitcounts and smem could use the same memory space if we'd read bitcount into a register
// and sync threads before doing any writes to smem.

//POSSIBLE SANITY CHECK -- is there any way to test if total_bit_count exceeds the amount of shared memory allocated?

// Loop til this thread's section of the bit array is finished.

  sieve_word = *bit_array;
  k_bit_base = threadIdx.x * words_per_thread * 32;
  for (i = total_bit_count - bitcount[threadIdx.x]; ; i++) {
    int bit_to_test;

// Make sure we have a non-zero sieve word

    while (sieve_word == 0) {
      if (--words_per_thread == 0) break;
      sieve_word = *++bit_array;
      k_bit_base += 32;
    }

// Check if this thread has processed all its set bits

    if (sieve_word == 0) break;

// Find a bit to test in the sieve word

    bit_to_test = 31 - ___clz (sieve_word);
    sieve_word &= ~(1 << bit_to_test);

// Copy the k value to the shared memory array

    smem[i] = k_bit_base + bit_to_test;
  }

  __syncthreads();

// Here, all warps in our block have placed their candidates in shared memory.
// Now we can start TFing candidates.

// Pre-init values used to compute factor

  // Compute base k value
  k_base.d0 = __add_cc (k_base.d0, __umul32  (blockIdx.x * bits_to_process, NUM_CLASSES));
  k_base.d1 = __addc   (k_base.d1, __umul32hi(blockIdx.x * bits_to_process, NUM_CLASSES)); /* k values are limited to 64 bits */

// Loop til the k values written to shared memory are exhausted

  for (i = threadIdx.x; i < total_bit_count; i += THREADS_PER_BLOCK) {
    int128 negf;
    int160 a, u, tmp160;
    int288 b, tmp288;
    float ff;
    int k_delta, shifter;

// Get the (k - k_base) value to test

    k_delta = smem[i];

// Compute f = 2 * k * M89 + 1 = k * 2^90 - 2k + 1

    f.d2 = __add_cc (k_base.d0, k_delta * NUM_CLASSES);	// k
    f.d3 = __addc   (k_base.d1, 0);

    f.d0 = __add_cc (f.d2, f.d2);	// 2k
    f.d1 = __addc   (f.d3, f.d3);

    f.d3 = (f.d3 << 26) + (f.d2 >> 6);	// k * 2^90
    f.d2 = (f.d2 << 26);

    f.d0 = __sub_cc (1, f.d0);		// 1-2k
    f.d1 = __subc   (0, f.d1);

    f.d2 = __sub_cc (f.d2, 1);		// propagate carry
    f.d3 = __subc   (f.d3, 0);

/*
ff = f as float
Precalculated here since it is the same for all steps in the following loop */
    ff= __uint2float_rn(f.d3);
    ff= ff * 4294967296.0f + __uint2float_rn(f.d2);
    ff=__int_as_float(0x3f7ffffb) / ff;			// just a little bit below 1.0f so we always underestimate the quotient

    tmp288.d8 = 0x10000;				// tmp288 is 2^272
    tmp288.d7 = 0; tmp288.d6 = 0; tmp288.d5 = 0; tmp288.d4 = 0;
    tmp288.d3 = 0; tmp288.d2 = 0; tmp288.d1 = 0; tmp288.d0 = 0;

    // Could write optimized div_288_128 with so many tmp288 elements known to be zero
    div_288_128(&u,tmp288,f,ff);			// u = floor(2^272 / f).  This requires f >= 113 bits.

							// b_preinit = 2^256
							// Let a = b_preinit / 2^112 = 2^144
							// tmp160 = a * u / 2^160
							//        = (b_preinit / 2^112) * (2^272 / f) / 2^160  (ignore the floor functions for now)
							// which if we do the math simplifies to the quotient: b_preinit / f
    tmp160.d0 = (u.d1 << 16) + (u.d0 >> 16);
    tmp160.d1 = (u.d2 << 16) + (u.d1 >> 16);
    tmp160.d2 = (u.d3 << 16) + (u.d2 >> 16);
    tmp160.d3 = (u.d4 << 16) + (u.d3 >> 16);
    tmp160.d4 =                (u.d4 >> 16);

    negf.d0 = __sub_cc (0, f.d0);			// Negate f so that the mulsub macros can use multiply-accumulate instructions
    negf.d1 = __subc_cc(0, f.d1);
    negf.d2 = __subc_cc(0, f.d2);
    negf.d3 = __subc   (0, f.d3);

    mulsub_160_128_initial(&a, tmp160, negf);		// Compute the remainder: b_preinit - quotient * f, we only compute the low 160-bits here

    for (shifter = 0; shifter < 81; shifter++)
    {
							// On input a is at most 131.459 bits (see end of this loop)

      square_160_288(&b, a);				// b = a^2, b is at most 262.918 bits

      a.d0 = (b.d4 << 16) + (b.d3 >> 16);		// a = b / 2^112, a is at most 150.918 bits
      a.d1 = (b.d5 << 16) + (b.d4 >> 16);
      a.d2 = (b.d6 << 16) + (b.d5 >> 16);
      a.d3 = (b.d7 << 16) + (b.d6 >> 16);
      a.d4 = (b.d8 << 16) + (b.d7 >> 16);

      mul_160_320_no_low5(&tmp160, a, u);		// tmp160 = (b / 2^112) * (2^272 / f) / 2^160    (ignore the floor functions for now)
							// which if we do the math simplifies to the quotient: b / f

							// The quotient is off by at most 10.  A full mul_160_320 would add 9 partial results
							// into tmp320.d4 which could have generated 8 carries into tmp320.d5.
							// Also, since u was generated with the floor function, it could be low by up to
							// almost 1.  If we account for this a value up to a.d4 could have been added into
							// tmp320.d4 possibly generating a carry.  Similarly, a was generated by a floor
							// function, and could thus be low by almost 1.  If we account for this a value up
							// to u.d4 could have been added into tmp320.d4 possibly generating a carry.
							// A grand total of up to 10 carries lost.

      mulsub_160_128(&a, b, tmp160, negf);		// Compute the remainder: b - quotient * f, we only compute the low 160-bits here

							// Since the quotient was up to 10 too small, the remainder has a maximum value of 11*f,
							// or 128 bits + log2 (11) bits, which is 131.459 bits.
    }

    mod_simple_160_128(&finalrem, a, f, ff);		// Adjustment.  The code above may produce an a that is too large by up to 10 times f.

#if 0
    if(cmp_ge_128(finalrem,f) && (f.d3 > 0xFFFF))
    {
      printf("EEEEEK, final rem is >= f\n");
    }
if ((blockIdx.x == 0 && threadIdx.x == 4)){
int160 f160;	    
f160.d0 = f.d0;
f160.d1 = f.d1;
f160.d2 = f.d2;
f160.d3 = f.d3;
f160.d4 = 0;
mul_160_320_no_low5(&tmp160,u,f160);
printf ("    f: %X %X %X %X\r\n", f.d3, f.d2, f.d1, f.d0);
printf ("u    : %X %X %X %X %X\r\n", u.d4, u.d3, u.d2, u.d1, u.d0);
printf ("u * f: %X %X %X %X %X\r\n", tmp160.d4, tmp160.d3, tmp160.d2, tmp160.d1, tmp160.d0);
printf ("  rem: %X %X %X %X\r\n", finalrem.d3, finalrem.d2, finalrem.d1, finalrem.d0);
}
#endif

/* check if we found a factor and write the factor to RES[] */

    if(finalrem.d0 == 2 && ((finalrem.d3 | finalrem.d2 | finalrem.d1) == 0))
    {
      int index=atomicInc(&RES[0],10000);
      RES[1]=4;
      if(index<10)				/* limit to 10 factors per class */
      {
	RES[index*4 + 2]=f.d0;
	RES[index*4 + 3]=f.d1;
	RES[index*4 + 4]=f.d2;
	RES[index*4 + 5]=f.d3;
      }
    }
  }

/* finally write occasional result for validation by C code */

  if(blockIdx.x == 0 && threadIdx.x == 0)
  {
    RES[RESULTS_ARRAY_VALIDATION_OFFSET]=4;
    RES[RESULTS_ARRAY_VALIDATION_OFFSET+1]=f.d0;
    RES[RESULTS_ARRAY_VALIDATION_OFFSET+2]=f.d1;
    RES[RESULTS_ARRAY_VALIDATION_OFFSET+3]=f.d2;
    RES[RESULTS_ARRAY_VALIDATION_OFFSET+4]=f.d3;
    RES[RESULTS_ARRAY_VALIDATION_OFFSET+5]=finalrem.d0;
    RES[RESULTS_ARRAY_VALIDATION_OFFSET+6]=finalrem.d1;
    RES[RESULTS_ARRAY_VALIDATION_OFFSET+7]=finalrem.d2;
    RES[RESULTS_ARRAY_VALIDATION_OFFSET+8]=finalrem.d3;
  }
}


//
// Kernel to factor MM89, works on f between 129 and 140 bits inclusive (k = 2^39 to k = 2^50)
//

__global__ void
__launch_bounds__(THREADS_PER_BLOCK, KERNEL_MIN_BLOCKS) mfaktc_barrett140_M89gs(int96 k_base, unsigned int *bit_array, unsigned int bits_to_process, unsigned int *RES)
{
  int i, words_per_thread, sieve_word, k_bit_base, total_bit_count;
  int160 f, finalrem;
  __shared__ volatile unsigned short bitcount[256];	// Each thread of our block puts bit-counts here
  extern __shared__ unsigned short smem[];		// Write bits to test here.  Launching program must estimate
							// how much shared memory to allocate based on number of primes sieved.

  // Get pointer to section of the bit_array this thread is processing.

  words_per_thread = bits_to_process / 8192;
  bit_array += blockIdx.x * bits_to_process / 32 + threadIdx.x * words_per_thread;

// Count number of bits set in this thread's word(s) from the bit_array

  bitcount[threadIdx.x] = 0;
  for (i = 0; i < words_per_thread; i++)
    bitcount[threadIdx.x] += ___popcnt(bit_array[i]);

// Create total count of bits set in block up to and including this threads popcnt.
// Kudos to Rocke Verser for the population counting code.
// CAUTION:  Following requires 256 threads per block

  // First five tallies remain within one warp.  Should be in lock-step.
  if (threadIdx.x & 1)        // If we are running on any thread 0bxxxxxxx1, tally neighbor's count.
    bitcount[threadIdx.x] += bitcount[threadIdx.x - 1];

  if (threadIdx.x & 2)        // If we are running on any thread 0bxxxxxx1x, tally neighbor's count.
    bitcount[threadIdx.x] += bitcount[(threadIdx.x - 2) | 1];

  if (threadIdx.x & 4)        // If we are running on any thread 0bxxxxx1xx, tally neighbor's count.
    bitcount[threadIdx.x] += bitcount[(threadIdx.x - 4) | 3];

  if (threadIdx.x & 8)        // If we are running on any thread 0bxxxx1xxx, tally neighbor's count.
    bitcount[threadIdx.x] += bitcount[(threadIdx.x - 8) | 7];

  if (threadIdx.x & 16)       // If we are running on any thread 0bxxx1xxxx, tally neighbor's count.
    bitcount[threadIdx.x] += bitcount[(threadIdx.x - 16) | 15];

  // Further tallies are across warps.  Must synchronize
  __syncthreads();
  if (threadIdx.x  & 32)      // If we are running on any thread 0bxx1xxxxx, tally neighbor's count.
    bitcount[threadIdx.x] += bitcount[(threadIdx.x - 32) | 31];

  __syncthreads();
  if (threadIdx.x & 64)       // If we are running on any thread 0bx1xxxxxx, tally neighbor's count.
    bitcount[threadIdx.x] += bitcount[(threadIdx.x - 64) | 63];

  __syncthreads();
  if (threadIdx.x & 128)       // If we are running on any thread 0b1xxxxxxx, tally neighbor's count.
    bitcount[threadIdx.x] += bitcount[127];

  // At this point, bitcount[...] contains the total number of bits for the indexed
  // thread plus all lower-numbered threads.  I.e., bitcount[255] is the total count.

  __syncthreads();
  total_bit_count = bitcount[255];

//POSSIBLE OPTIMIZATION - bitcounts and smem could use the same memory space if we'd read bitcount into a register
// and sync threads before doing any writes to smem.

//POSSIBLE SANITY CHECK -- is there any way to test if total_bit_count exceeds the amount of shared memory allocated?

// Loop til this thread's section of the bit array is finished.

  sieve_word = *bit_array;
  k_bit_base = threadIdx.x * words_per_thread * 32;
  for (i = total_bit_count - bitcount[threadIdx.x]; ; i++) {
    int bit_to_test;

// Make sure we have a non-zero sieve word

    while (sieve_word == 0) {
      if (--words_per_thread == 0) break;
      sieve_word = *++bit_array;
      k_bit_base += 32;
    }

// Check if this thread has processed all its set bits

    if (sieve_word == 0) break;

// Find a bit to test in the sieve word

    bit_to_test = 31 - ___clz (sieve_word);
    sieve_word &= ~(1 << bit_to_test);

// Copy the k value to the shared memory array

    smem[i] = k_bit_base + bit_to_test;
  }

  __syncthreads();

// Here, all warps in our block have placed their candidates in shared memory.
// Now we can start TFing candidates.

// Pre-init values used to compute factor

  // Compute base k value
  k_base.d0 = __add_cc (k_base.d0, __umul32  (blockIdx.x * bits_to_process, NUM_CLASSES));
  k_base.d1 = __addc   (k_base.d1, __umul32hi(blockIdx.x * bits_to_process, NUM_CLASSES)); /* k values are limited to 64 bits */

// Loop til the k values written to shared memory are exhausted

  for (i = threadIdx.x; i < total_bit_count; i += THREADS_PER_BLOCK) {
    int160 a, u, tmp160, negf;
    int288 b, tmp288;
    float ff;
    int k_delta, shifter;

// Get the (k - k_base) value to test

    k_delta = smem[i];

// Compute f = 2 * k * M89 + 1 = k * 2^90 - 2k + 1

    f.d2 = __add_cc (k_base.d0, k_delta * NUM_CLASSES);	// k
    f.d3 = __addc   (k_base.d1, 0);

    f.d0 = __add_cc (f.d2, f.d2);	// 2k
    f.d1 = __addc   (f.d3, f.d3);

    f.d4 =                (f.d3 >> 6);	// k * 2^90
    f.d3 = (f.d3 << 26) + (f.d2 >> 6);
    f.d2 = (f.d2 << 26);

    f.d0 = __sub_cc (1, f.d0);		// 1-2k
    f.d1 = __subc   (0, f.d1);

    f.d2 = __sub_cc  (f.d2, 1);		// propagate carry
    f.d3 = __subc_cc (f.d3, 0);
    f.d4 = __subc    (f.d4, 0);

/*
ff = f as float
Precalculated here since it is the same for all steps in the following loop */
    ff= __uint2float_rn(f.d4);
    ff= ff * 4294967296.0f + __uint2float_rn(f.d3);
    ff=__int_as_float(0x3f7ffffb) / ff;			// just a little bit below 1.0f so we always underestimate the quotient

    tmp288.d8 = 0xFFFFFFFF;				// tmp288 is nearly 2^288
    tmp288.d7 = 0xFFFFFFFF; tmp288.d6 = 0xFFFFFFFF; tmp288.d5 = 0xFFFFFFFF; tmp288.d4 = 0xFFFFFFFF;
    tmp288.d3 = 0xFFFFFFFF; tmp288.d2 = 0xFFFFFFFF; tmp288.d1 = 0xFFFFFFFF; tmp288.d0 = 0xFFFFFFFF;

    // Could write optimized div_288_160 with so many tmp288 elements known to be zero
    div_288_160(&u,tmp288,f,ff);			// u = floor(2^288 / f).  This requires f >= 129 bits.

							// b_preinit = 2^256
							// Let a = b_preinit / 2^128 = 2^128
							// tmp160 = a * u / 2^160
							//        = (b_preinit / 2^128) * (2^288 / f) / 2^160   (ignore the floor functions for now)
							// which if we do the math simplifies to the quotient: b_preinit / f
    tmp160.d0 = u.d1;
    tmp160.d1 = u.d2;
    tmp160.d2 = u.d3;
    tmp160.d3 = u.d4;

    negf.d0 = __sub_cc (0, f.d0);			// Negate f so that the mulsub macros can use multiply-accumulate instructions
    negf.d1 = __subc_cc(0, f.d1);
    negf.d2 = __subc_cc(0, f.d2);
    negf.d3 = __subc_cc(0, f.d3);
    negf.d4 = __subc   (0, f.d4);

    mulsub_160_M89_initial_special(&a, tmp160, negf);	// Compute the remainder: b_preinit - quotient * f, we only compute the low 160-bits here

    for (shifter = 0; shifter < 81; shifter++)
    {
							// On input a is at most 143.459 bits (see end of this loop)

      square_160_288(&b, a);				// b = a^2, b is at most 286.918 bits

      a.d0 = b.d4;					// a = b / 2^128, a is at most 158.918 bits
      a.d1 = b.d5;
      a.d2 = b.d6;
      a.d3 = b.d7;
      a.d4 = b.d8;

      mul_160_320_no_low5(&tmp160, a, u);		// tmp160 = (b / 2^128) * (2^288 / f) / 2^160    (ignore the floor functions for now)
							// which if we do the math simplifies to the quotient: b / f

							// The quotient is off by at most 10.  A full mul_160_320 would add 9 partial results
							// into tmp320.d4 which could have generated 8 carries into tmp320.d5.
							// Also, since u was generated with the floor function, it could be low by up to
							// almost 1.  If we account for this a value up to a.d4 could have been added into
							// tmp320.d4 possibly generating a carry.  Similarly, a was generated by a floor
							// function, and could thus be low by almost 1.  If we account for this a value up
							// to u.d4 could have been added into tmp320.d4 possibly generating a carry.
							// A grand total of up to 10 carries lost.

      mulsub_160_288(&a, b, tmp160, negf);		// Compute the remainder: b - quotient * f, we only compute the low 160-bits here

							// Since the quotient was up to 10 too small, the remainder has a maximum value of 11*f,
							// or 140 bits + log2 (11) bits, which is 143.459 bits.
    }

    mod_simple_160(&finalrem, a, f, ff);		// Adjustment.  The code above may produce an a that is too large by up to 10 times f.

#if 0
    if(cmp_ge_160(finalrem,f) && f.d4)
    {
      printf("EEEEEK, final finalrem is >= f\n");
    }
if (blockIdx.x == 12 && threadIdx.x == 4){
mul_160_320_no_low5(&tmp160,u,f);
printf ("    f: %X %X %X %X %X\r\n", f.d4, f.d3, f.d2, f.d1, f.d0);
printf ("u    : %X %X %X %X %X\r\n", u.d4, u.d3, u.d2, u.d1, u.d0);
printf ("u * f: %X %X %X %X %X\r\n", tmp160.d4, tmp160.d3, tmp160.d2, tmp160.d1, tmp160.d0);
printf ("  rem: %X %X %X %X %X\r\n", finalrem.d4, finalrem.d3, finalrem.d2, finalrem.d1, finalrem.d0);
}
#endif

/* check if we found a factor and write the factor to RES[] */

    if(finalrem.d0 == 2 && ((finalrem.d4 | finalrem.d3 | finalrem.d2 | finalrem.d1) == 0))
    {
      int index=atomicInc(&RES[0],10000);
      RES[1]=5;
      if(index<10)				/* limit to 10 factors per class */
      {
	RES[index*5 + 2]=f.d0;
	RES[index*5 + 3]=f.d1;
	RES[index*5 + 4]=f.d2;
	RES[index*5 + 5]=f.d3;
	RES[index*5 + 6]=f.d4;
      }
    }
  }

/* finally write occasional result for validation by C code */

  if(blockIdx.x == 0 && threadIdx.x == 0)
  {
    RES[RESULTS_ARRAY_VALIDATION_OFFSET]=5;
    RES[RESULTS_ARRAY_VALIDATION_OFFSET+1]=f.d0;
    RES[RESULTS_ARRAY_VALIDATION_OFFSET+2]=f.d1;
    RES[RESULTS_ARRAY_VALIDATION_OFFSET+3]=f.d2;
    RES[RESULTS_ARRAY_VALIDATION_OFFSET+4]=f.d3;
    RES[RESULTS_ARRAY_VALIDATION_OFFSET+5]=f.d4;
    RES[RESULTS_ARRAY_VALIDATION_OFFSET+6]=finalrem.d0;
    RES[RESULTS_ARRAY_VALIDATION_OFFSET+7]=finalrem.d1;
    RES[RESULTS_ARRAY_VALIDATION_OFFSET+8]=finalrem.d2;
    RES[RESULTS_ARRAY_VALIDATION_OFFSET+9]=finalrem.d3;
    RES[RESULTS_ARRAY_VALIDATION_OFFSET+10]=finalrem.d4;
  }
}


//
// Kernel to factor MM89, works on f between 141 and 152 bits inclusive (k = 2^51 to k = 2^61)
//

__global__ void
__launch_bounds__(THREADS_PER_BLOCK, KERNEL_MIN_BLOCKS) mfaktc_barrett152_M89gs(int96 k_base, unsigned int *bit_array, unsigned int bits_to_process, unsigned int *RES, unsigned int bits_max)
{
  int i, words_per_thread, sieve_word, k_bit_base, total_bit_count;
  int160 f, finalrem;
  __shared__ volatile unsigned short bitcount[256];	// Each thread of our block puts bit-counts here
  extern __shared__ unsigned short smem[];		// Write bits to test here.  Launching program must estimate
							// how much shared memory to allocate based on number of primes sieved.

  // Get pointer to section of the bit_array this thread is processing.

  words_per_thread = bits_to_process / 8192;
  bit_array += blockIdx.x * bits_to_process / 32 + threadIdx.x * words_per_thread;

// Count number of bits set in this thread's word(s) from the bit_array

  bitcount[threadIdx.x] = 0;
  for (i = 0; i < words_per_thread; i++)
    bitcount[threadIdx.x] += ___popcnt(bit_array[i]);

// Create total count of bits set in block up to and including this threads popcnt.
// Kudos to Rocke Verser for the population counting code.
// CAUTION:  Following requires 256 threads per block

  // First five tallies remain within one warp.  Should be in lock-step.
  if (threadIdx.x & 1)        // If we are running on any thread 0bxxxxxxx1, tally neighbor's count.
    bitcount[threadIdx.x] += bitcount[threadIdx.x - 1];

  if (threadIdx.x & 2)        // If we are running on any thread 0bxxxxxx1x, tally neighbor's count.
    bitcount[threadIdx.x] += bitcount[(threadIdx.x - 2) | 1];

  if (threadIdx.x & 4)        // If we are running on any thread 0bxxxxx1xx, tally neighbor's count.
    bitcount[threadIdx.x] += bitcount[(threadIdx.x - 4) | 3];

  if (threadIdx.x & 8)        // If we are running on any thread 0bxxxx1xxx, tally neighbor's count.
    bitcount[threadIdx.x] += bitcount[(threadIdx.x - 8) | 7];

  if (threadIdx.x & 16)       // If we are running on any thread 0bxxx1xxxx, tally neighbor's count.
    bitcount[threadIdx.x] += bitcount[(threadIdx.x - 16) | 15];

  // Further tallies are across warps.  Must synchronize
  __syncthreads();
  if (threadIdx.x  & 32)      // If we are running on any thread 0bxx1xxxxx, tally neighbor's count.
    bitcount[threadIdx.x] += bitcount[(threadIdx.x - 32) | 31];

  __syncthreads();
  if (threadIdx.x & 64)       // If we are running on any thread 0bx1xxxxxx, tally neighbor's count.
    bitcount[threadIdx.x] += bitcount[(threadIdx.x - 64) | 63];

  __syncthreads();
  if (threadIdx.x & 128)       // If we are running on any thread 0b1xxxxxxx, tally neighbor's count.
    bitcount[threadIdx.x] += bitcount[127];

  // At this point, bitcount[...] contains the total number of bits for the indexed
  // thread plus all lower-numbered threads.  I.e., bitcount[255] is the total count.

  __syncthreads();
  total_bit_count = bitcount[255];

//POSSIBLE OPTIMIZATION - bitcounts and smem could use the same memory space if we'd read bitcount into a register
// and sync threads before doing any writes to smem.

//POSSIBLE SANITY CHECK -- is there any way to test if total_bit_count exceeds the amount of shared memory allocated?

// Loop til this thread's section of the bit array is finished.

  sieve_word = *bit_array;
  k_bit_base = threadIdx.x * words_per_thread * 32;
  for (i = total_bit_count - bitcount[threadIdx.x]; ; i++) {
    int bit_to_test;

// Make sure we have a non-zero sieve word

    while (sieve_word == 0) {
      if (--words_per_thread == 0) break;
      sieve_word = *++bit_array;
      k_bit_base += 32;
    }

// Check if this thread has processed all its set bits

    if (sieve_word == 0) break;

// Find a bit to test in the sieve word

    bit_to_test = 31 - ___clz (sieve_word);
    sieve_word &= ~(1 << bit_to_test);

// Copy the k value to the shared memory array

    smem[i] = k_bit_base + bit_to_test;
  }

  __syncthreads();

// Here, all warps in our block have placed their candidates in shared memory.
// Now we can start TFing candidates.

// Pre-init values used to compute factor

  // Compute base k value
  k_base.d0 = __add_cc (k_base.d0, __umul32  (blockIdx.x * bits_to_process, NUM_CLASSES));
  k_base.d1 = __addc   (k_base.d1, __umul32hi(blockIdx.x * bits_to_process, NUM_CLASSES)); /* k values are limited to 64 bits */

// Loop til the k values written to shared memory are exhausted

  for (i = threadIdx.x; i < total_bit_count; i += THREADS_PER_BLOCK) {
    int160 a, u, tmp160, negf;
    int320 b, tmp320;
    float ff;
    int k_delta, shifter;

// Get the (k - k_base) value to test

    k_delta = smem[i];

// Compute f = 2 * k * M89 + 1 = k * 2^90 - 2k + 1

    f.d2 = __add_cc (k_base.d0, k_delta * NUM_CLASSES);	// k
    f.d3 = __addc   (k_base.d1, 0);

    f.d0 = __add_cc (f.d2, f.d2);	// 2k
    f.d1 = __addc   (f.d3, f.d3);

    f.d4 =                (f.d3 >> 6);	// k * 2^90
    f.d3 = (f.d3 << 26) + (f.d2 >> 6);
    f.d2 = (f.d2 << 26);

    f.d0 = __sub_cc (1, f.d0);		// 1-2k
    f.d1 = __subc   (0, f.d1);

    f.d2 = __sub_cc  (f.d2, 1);		// propagate carry
    f.d3 = __subc_cc (f.d3, 0);
    f.d4 = __subc    (f.d4, 0);

/*
ff = f as float
Precalculated here since it is the same for all steps in the following loop */
    ff= __uint2float_rn(f.d4);
    ff= ff * 4294967296.0f + __uint2float_rn(f.d3);
    ff=__int_as_float(0x3f7ffffb) / ff;			// just a little bit below 1.0f so we always underestimate the quotient

    tmp320.d9 = 1 << (bits_max - 1);			// tmp320 = 2^(159 + bits_in_f)
    tmp320.d8 = 0; tmp320.d7 = 0; tmp320.d6 = 0; tmp320.d5 = 0; tmp320.d4 = 0;
    tmp320.d3 = 0; tmp320.d2 = 0; tmp320.d1 = 0; tmp320.d0 = 0;

    // Could write optimized div_320_160 with so many tmp320 elements known to be zero
    div_320_160(&u,tmp320,f,ff);			// u = floor(2^(159 + bits_in_f) / f), giving 160 bits of precision

							// b_preinit = 2^256
							// Let a = b_preinit / 2 ^ (bits_in_f - 1)
							// tmp160 = a * u / 2^160
							//        = (b_preinit / 2 ^ (bits_in_f - 1)) * (2 ^ (159 + bits_in_f) / f) / 2^160   (ignore the floor functions for now)
							// which if we do the math simplifies to the quotient: b_preinit / f
    tmp160.d0 = (u.d1 >> (bits_max - 1)) + (u.d2 << (32 - (bits_max - 1)));
    tmp160.d1 = (u.d2 >> (bits_max - 1)) + (u.d3 << (32 - (bits_max - 1)));
    tmp160.d2 = (u.d3 >> (bits_max - 1)) + (u.d4 << (32 - (bits_max - 1)));
    tmp160.d3 = (u.d4 >> (bits_max - 1));

    negf.d0 = __sub_cc (0, f.d0);			// Negate f so that the mulsub macros can use multiply-accumulate instructions
    negf.d1 = __subc_cc(0, f.d1);
    negf.d2 = __subc_cc(0, f.d2);
    negf.d3 = __subc_cc(0, f.d3);
    negf.d4 = __subc   (0, f.d4);

    mulsub_160_M89_initial_special(&a, tmp160, negf);	// Compute the remainder: b_preinit - quotient * f, we only compute the low 160-bits here

    for (shifter = 0; shifter < 81; shifter++)
    {
							// On input a is at most 155.459 bits (see end of this loop)

      square_160_320(&b, a);				// b = a^2, b is at most 310.918 bits

      a.d0 = (b.d4 >> (bits_max - 1)) + (b.d5 << (32 - (bits_max - 1))); // a = b / (2 ^ (bits_in_f - 1)), a is at most 159.918 bits
      a.d1 = (b.d5 >> (bits_max - 1)) + (b.d6 << (32 - (bits_max - 1)));
      a.d2 = (b.d6 >> (bits_max - 1)) + (b.d7 << (32 - (bits_max - 1)));
      a.d3 = (b.d7 >> (bits_max - 1)) + (b.d8 << (32 - (bits_max - 1)));
      a.d4 = (b.d8 >> (bits_max - 1)) + (b.d9 << (32 - (bits_max - 1)));

      mul_160_320_no_low5(&tmp160, a, u);		// tmp160 = (b / 2 ^ (bits_in_f - 1)) * (2 ^ (159 + bits_in_f) / f) / 2^160   (ignore the floor functions for now)
							// which if we do the math simplifies to the quotient: b / f

							// The quotient is off by at most 10.  A full mul_160_320 would add 9 partial results
							// into tmp320.d4 which could have generated 8 carries into tmp320.d5.
							// Also, since u was generated with the floor function, it could be low by up to
							// almost 1.  If we account for this a value up to a.d4 could have been added into
							// tmp320.d4 possibly generating a carry.  Similarly, a was generated by a floor
							// function, and could thus be low by almost 1.  If we account for this a value up
							// to u.d4 could have been added into tmp320.d4 possibly generating a carry.
							// A grand total of up to 10 carries lost.

      mulsub_160(&a, b, tmp160, negf);			// Compute the remainder: b - quotient * f, we only compute the low 160-bits here

							// Since the quotient was up to 10 too small, the remainder has a maximum value of 11*f,
							// or 152 bits + log2 (11) bits, which is 155.459 bits.
    }

    mod_simple_160(&finalrem, a, f, ff);		// Adjustment.  The code above may produce an a that is too large by up to 10 times f.

#if 0
    if(cmp_ge_160(finalrem,f))
    {
      printf("EEEEEK, final finalrem is >= f\n");
    }
if (blockIdx.x == 12 && threadIdx.x == 4){
mul_160_320_no_low5(&tmp160,u,f);
printf ("    f: %X %X %X %X %X\r\n", f.d4, f.d3, f.d2, f.d1, f.d0);
printf ("u    : %X %X %X %X %X\r\n", u.d4, u.d3, u.d2, u.d1, u.d0);
printf ("u * f: %X %X %X %X %X\r\n", tmp160.d4, tmp160.d3, tmp160.d2, tmp160.d1, tmp160.d0);
printf ("  rem: %X %X %X %X %X\r\n", finalrem.d4, finalrem.d3, finalrem.d2, finalrem.d1, finalrem.d0);
}
#endif

/* check if we found a factor and write the factor to RES[] */

    if(finalrem.d0 == 2 && ((finalrem.d4 | finalrem.d3 | finalrem.d2 | finalrem.d1) == 0))
    {
      int index=atomicInc(&RES[0],10000);
      RES[1]=5;
      if(index<10)				/* limit to 10 factors per class */
      {
	RES[index*5 + 2]=f.d0;
	RES[index*5 + 3]=f.d1;
	RES[index*5 + 4]=f.d2;
	RES[index*5 + 5]=f.d3;
	RES[index*5 + 6]=f.d4;
      }
    }
  }

/* finally write occasional result for validation by C code */

  if(blockIdx.x == 0 && threadIdx.x == 0)
  {
    RES[RESULTS_ARRAY_VALIDATION_OFFSET]=5;
    RES[RESULTS_ARRAY_VALIDATION_OFFSET+1]=f.d0;
    RES[RESULTS_ARRAY_VALIDATION_OFFSET+2]=f.d1;
    RES[RESULTS_ARRAY_VALIDATION_OFFSET+3]=f.d2;
    RES[RESULTS_ARRAY_VALIDATION_OFFSET+4]=f.d3;
    RES[RESULTS_ARRAY_VALIDATION_OFFSET+5]=f.d4;
    RES[RESULTS_ARRAY_VALIDATION_OFFSET+6]=finalrem.d0;
    RES[RESULTS_ARRAY_VALIDATION_OFFSET+7]=finalrem.d1;
    RES[RESULTS_ARRAY_VALIDATION_OFFSET+8]=finalrem.d2;
    RES[RESULTS_ARRAY_VALIDATION_OFFSET+9]=finalrem.d3;
    RES[RESULTS_ARRAY_VALIDATION_OFFSET+10]=finalrem.d4;
  }
}


//
// Kernel to factor MM89, works on f between 152 and 160 bits inclusive (k = 2^62 to k = 2^70 (actual max is 2^63))
//

__global__ void
__launch_bounds__(THREADS_PER_BLOCK, KERNEL_MAX_BLOCKS) mfaktc_barrett160_M89gs(int96 k_base, unsigned int *bit_array, unsigned int bits_to_process, unsigned int *RES)
{
  int i, words_per_thread, sieve_word, k_bit_base, total_bit_count;
  int160 f, finalrem;
  __shared__ volatile unsigned short bitcount[256];	// Each thread of our block puts bit-counts here
  extern __shared__ unsigned short smem[];		// Write bits to test here.  Launching program must estimate
							// how much shared memory to allocate based on number of primes sieved.

  // Get pointer to section of the bit_array this thread is processing.

  words_per_thread = bits_to_process / 8192;
  bit_array += blockIdx.x * bits_to_process / 32 + threadIdx.x * words_per_thread;

// Count number of bits set in this thread's word(s) from the bit_array

  bitcount[threadIdx.x] = 0;
  for (i = 0; i < words_per_thread; i++)
    bitcount[threadIdx.x] += ___popcnt(bit_array[i]);

// Create total count of bits set in block up to and including this threads popcnt.
// Kudos to Rocke Verser for the population counting code.
// CAUTION:  Following requires 256 threads per block

  // First five tallies remain within one warp.  Should be in lock-step.
  if (threadIdx.x & 1)        // If we are running on any thread 0bxxxxxxx1, tally neighbor's count.
    bitcount[threadIdx.x] += bitcount[threadIdx.x - 1];

  if (threadIdx.x & 2)        // If we are running on any thread 0bxxxxxx1x, tally neighbor's count.
    bitcount[threadIdx.x] += bitcount[(threadIdx.x - 2) | 1];

  if (threadIdx.x & 4)        // If we are running on any thread 0bxxxxx1xx, tally neighbor's count.
    bitcount[threadIdx.x] += bitcount[(threadIdx.x - 4) | 3];

  if (threadIdx.x & 8)        // If we are running on any thread 0bxxxx1xxx, tally neighbor's count.
    bitcount[threadIdx.x] += bitcount[(threadIdx.x - 8) | 7];

  if (threadIdx.x & 16)       // If we are running on any thread 0bxxx1xxxx, tally neighbor's count.
    bitcount[threadIdx.x] += bitcount[(threadIdx.x - 16) | 15];

  // Further tallies are across warps.  Must synchronize
  __syncthreads();
  if (threadIdx.x  & 32)      // If we are running on any thread 0bxx1xxxxx, tally neighbor's count.
    bitcount[threadIdx.x] += bitcount[(threadIdx.x - 32) | 31];

  __syncthreads();
  if (threadIdx.x & 64)       // If we are running on any thread 0bx1xxxxxx, tally neighbor's count.
    bitcount[threadIdx.x] += bitcount[(threadIdx.x - 64) | 63];

  __syncthreads();
  if (threadIdx.x & 128)       // If we are running on any thread 0b1xxxxxxx, tally neighbor's count.
    bitcount[threadIdx.x] += bitcount[127];

  // At this point, bitcount[...] contains the total number of bits for the indexed
  // thread plus all lower-numbered threads.  I.e., bitcount[255] is the total count.

  __syncthreads();
  total_bit_count = bitcount[255];

//POSSIBLE OPTIMIZATION - bitcounts and smem could use the same memory space if we'd read bitcount into a register
// and sync threads before doing any writes to smem.

//POSSIBLE SANITY CHECK -- is there any way to test if total_bit_count exceeds the amount of shared memory allocated?

// Loop til this thread's section of the bit array is finished.

  sieve_word = *bit_array;
  k_bit_base = threadIdx.x * words_per_thread * 32;
  for (i = total_bit_count - bitcount[threadIdx.x]; ; i++) {
    int bit_to_test;

// Make sure we have a non-zero sieve word

    while (sieve_word == 0) {
      if (--words_per_thread == 0) break;
      sieve_word = *++bit_array;
      k_bit_base += 32;
    }

// Check if this thread has processed all its set bits

    if (sieve_word == 0) break;

// Find a bit to test in the sieve word

    bit_to_test = 31 - ___clz (sieve_word);
    sieve_word &= ~(1 << bit_to_test);

// Copy the k value to the shared memory array

    smem[i] = k_bit_base + bit_to_test;
  }

  __syncthreads();

// Here, all warps in our block have placed their candidates in shared memory.
// Now we can start TFing candidates.

// Pre-init values used to compute factor

  // Compute base k value
  k_base.d0 = __add_cc (k_base.d0, __umul32  (blockIdx.x * bits_to_process, NUM_CLASSES));
  k_base.d1 = __addc   (k_base.d1, __umul32hi(blockIdx.x * bits_to_process, NUM_CLASSES)); /* k values are limited to 64 bits */

// Loop til the k values written to shared memory are exhausted

  for (i = threadIdx.x; i < total_bit_count; i += THREADS_PER_BLOCK) {
    int160 negf;
    int192 a, u, tmp192;
    int352 b, tmp352;
    float ff;
    int k_delta, shifter;

// Get the (k - k_base) value to test

    k_delta = smem[i];

// Compute f = 2 * k * M89 + 1 = k * 2^90 - 2k + 1

    f.d2 = __add_cc (k_base.d0, k_delta * NUM_CLASSES);	// k
    f.d3 = __addc   (k_base.d1, 0);

    f.d0 = __add_cc (f.d2, f.d2);	// 2k, our carry handling here limits k to 2^63
    f.d1 = __addc   (f.d3, f.d3);

    f.d4 =                (f.d3 >> 6);	// k * 2^90
    f.d3 = (f.d3 << 26) + (f.d2 >> 6);
    f.d2 = (f.d2 << 26);

    f.d0 = __sub_cc (1, f.d0);		// 1-2k
    f.d1 = __subc   (0, f.d1);

    f.d2 = __sub_cc  (f.d2, 1);		// propagate carry
    f.d3 = __subc_cc (f.d3, 0);
    f.d4 = __subc    (f.d4, 0);

/*
ff = f as float
Precalculated here since it is the same for all steps in the following loop */
    ff= __uint2float_rn(f.d4);
    ff= ff * 4294967296.0f + __uint2float_rn(f.d3);
    ff=__int_as_float(0x3f7ffffb) / ff;			// just a little bit below 1.0f so we always underestimate the quotient

    tmp352.d10 = 0x00010000;				// tmp352 is 2^336
    tmp352.d9 = 0; tmp352.d8 = 0; tmp352.d7 = 0; tmp352.d6 = 0; tmp352.d5 = 0;
    tmp352.d4 = 0; tmp352.d3 = 0; tmp352.d2 = 0; tmp352.d1 = 0; tmp352.d0 = 0;

    // Could write optimized div_352_160 with so many tmp352 elements known to be zero
    div_352_160(&u,tmp352,f,ff);			// u = floor(2^336 / f).  This requires f >= 145 bits.

							// b_preinit = 2^256
							// Let a = b_preinit / 2^144 = 2^112
							// tmp192 = a * u / 2^192
							//        = (b_preinit / 2^144) * (2^336 / f) / 2^192  (ignore the floor functions for now)
							// which if we do the math simplifies to the quotient: b_preinit / f
    tmp192.d0 = (u.d3 << 16) + (u.d2 >> 16);
    tmp192.d1 = (u.d4 << 16) + (u.d3 >> 16);
    tmp192.d2 = (u.d5 << 16) + (u.d4 >> 16);
    tmp192.d3 =                (u.d5 >> 16);

    negf.d0 = __sub_cc (0, f.d0);			// Negate f so that the mulsub macros can use multiply-accumulate instructions
    negf.d1 = __subc_cc(0, f.d1);
    negf.d2 = __subc_cc(0, f.d2);
    negf.d3 = __subc_cc(0, f.d3);
    negf.d4 = __subc   (0, f.d4);

    mulsub_192_160_M89_initial_special16(&a, tmp192, negf); // Compute the remainder: b_preinit - quotient * f, we only compute the low 192-bits here

    for (shifter = 0; shifter < 81; shifter++)
    {
							// On input a is at most 163.700 bits (see end of this loop)

      square_192_352(&b, a);				// b = a^2, b is at most 327.400 bits

      a.d0 = (b.d5 << 16) + (b.d4 >> 16);		// a = b / 2^144, a is at most 183.400 bits
      a.d1 = (b.d6 << 16) + (b.d5 >> 16);
      a.d2 = (b.d7 << 16) + (b.d6 >> 16);
      a.d3 = (b.d8 << 16) + (b.d7 >> 16);
      a.d4 = (b.d9 << 16) + (b.d8 >> 16);
      a.d5 = (b.d10 << 16) + (b.d9 >> 16);

      mul_192_384_no_low6(&tmp192, a, u);		// tmp192 = (b / 2^144) * (2^336 / f) / 2^192    (ignore the floor functions for now)
							// which if we do the math simplifies to the quotient: b / f

							// The quotient is off by at most 12.  A full mul_192_384 would add 11 partial results
							// into tmp384.d5 which could have generated 10 carries into tmp384.d6.
							// Also, since u was generated with the floor function, it could be low by up to
							// almost 1.  If we account for this a value up to a.d5 could have been added into
							// tmp384.d5 possibly generating a carry.  Similarly, a was generated by a floor
							// function, and could thus be low by almost 1.  If we account for this a value up
							// to u.d5 could have been added into tmp384.d5 possibly generating a carry.
							// A grand total of up to 12 carries lost.

      mulsub_192_160(&a, b, tmp192, negf);		// Compute the remainder: b - quotient * f, we only compute the low 192-bits here

							// Since the quotient was up to 12 too small, the remainder has a maximum value of 13*f,
							// or 160 bits + log2 (13) bits, which is 163.700 bits.
    }

    mod_simple_192_160(&finalrem, a, f, ff);		// Adjustment.  The code above may produce an a that is too large by up to 13 times f.

#if 0
    if(cmp_ge_160(finalrem,f))
    {
      printf("EEEEEK, final finalrem is >= f\n");
    }
if (blockIdx.x == 12 && threadIdx.x == 4){
int192 f192;	    
f192.d0 = f.d0;
f192.d1 = f.d1;
f192.d2 = f.d2;
f192.d3 = f.d3;
f192.d4 = f.d4;
f192.d5 = 0;
mul_192_384_no_low6(&tmp192,u,f192);
printf ("    f: %08X%08X%08X%08X%08X\r\n", f.d4, f.d3, f.d2, f.d1, f.d0);
printf ("u    : %X %X %X %X %X %X\r\n", u.d5, u.d4, u.d3, u.d2, u.d1, u.d0);
printf ("u * f: %X %X %X %X %X %X\r\n", tmp192.d5, tmp192.d4, tmp192.d3, tmp192.d2, tmp192.d1, tmp192.d0);
printf ("  rem: %08X%08X%08X%08X%08X\r\n", finalrem.d4, finalrem.d3, finalrem.d2, finalrem.d1, finalrem.d0);
}
#endif

/* check if we found a factor and write the factor to RES[] */

    if(finalrem.d0 == 2 && ((finalrem.d4 | finalrem.d3 | finalrem.d2 | finalrem.d1) == 0))
    {
      int index=atomicInc(&RES[0],10000);
      RES[1]=5;
      if(index<10)				/* limit to 10 factors per class */
      {
	RES[index*5 + 2]=f.d0;
	RES[index*5 + 3]=f.d1;
	RES[index*5 + 4]=f.d2;
	RES[index*5 + 5]=f.d3;
	RES[index*5 + 6]=f.d4;
      }
    }
  }

/* finally write occasional result for validation by C code */

  if(blockIdx.x == 0 && threadIdx.x == 0)
  {
    RES[RESULTS_ARRAY_VALIDATION_OFFSET]=5;
    RES[RESULTS_ARRAY_VALIDATION_OFFSET+1]=f.d0;
    RES[RESULTS_ARRAY_VALIDATION_OFFSET+2]=f.d1;
    RES[RESULTS_ARRAY_VALIDATION_OFFSET+3]=f.d2;
    RES[RESULTS_ARRAY_VALIDATION_OFFSET+4]=f.d3;
    RES[RESULTS_ARRAY_VALIDATION_OFFSET+5]=f.d4;
    RES[RESULTS_ARRAY_VALIDATION_OFFSET+6]=finalrem.d0;
    RES[RESULTS_ARRAY_VALIDATION_OFFSET+7]=finalrem.d1;
    RES[RESULTS_ARRAY_VALIDATION_OFFSET+8]=finalrem.d2;
    RES[RESULTS_ARRAY_VALIDATION_OFFSET+9]=finalrem.d3;
    RES[RESULTS_ARRAY_VALIDATION_OFFSET+10]=finalrem.d4;
  }
}
